local Bot = Entity:extend("Bot")

function Bot:__init__(kwargs)
    self.super.__init__(self,kwargs)
    kwargs = kwargs or {}
    self._kwargs = kwargs
    self.angle = 0---2--1+math.pi/2--kwargs.angle or 0
    self.x = kwargs.x or 0
    self.y = kwargs.y or 0
    self.h = kwargs.h or 16
    self.w = kwargs.w or 16
    self.sight = kwargs.sight or 10
    self.source = kwargs.source or "player.png"
    self.isBackground = true--???
    
    --self.collider = self.map.world:newRectangleCollider(self.x,self.y,self.w,self.h)

    self.speed = {x=0,y=0}
    self.weight = 400
    self.gravity = 0
    self.initGravity = 0

    self._speed = 100
    self.bullets = {}
    self.bulletLen = 0
    
    self.jumpAcceleration = 400--300
    self.runAccel = 500
    self.brakeAccel = 2000
    self.maxVx = 200
    self.maxVy = 1400
    self.maxCrawlX = 100
    self.maxCrawlY = 100
    self.isCrawling = false
    
    self.old = {x=self.x,y=self.y}
    
    self._toBuild = {}
    self._builtList = {}
    self._toBuildList = {}
    
    self.digH = kwargs.digH or 50
    self.digW = kwargs.digW or 50
    self.digOptions = kwargs.digOptions or {}
    self.digOffset = kwargs.digOffset or {x=0,y=0}
    self._tunnelType = kwargs.tunnelType or "Digger"
    
    self.purpose = false
    self.target = nil
    self:activate()
end

function Bot:activate()
    self.target = nil
    local function saveTunnel(...) return self:saveTunnel(...) end
    self._tunnel = rot.Map[self._tunnelType](self.digW, self.digH, self.digOptions)
    self.purpose = true
    self._tunnel:create(saveTunnel)
end

function Bot:saveTunnel(_x, _y, val)
    if val == 1 then return end--don't include walls
    local x = _x + self.digOffset.x
    local y = _y + self.digOffset.y
    self._toBuild[x] = self._toBuild[x] or {}
    self._toBuild[x][y] = val
    local t = self.map:getTile(x,y)
    if t and check then t.color = getColor("red") end
    local pos = {x=x,y=y,val=val}
    table.insert(self._toBuildList, pos)
end
check =1
function Bot:getTargetTile()
    if #self._toBuildList<0 then
        self.purpose = false
        return
    end
    
    local t
    local targ
    local sight = 30
    local fov = self.map.fov
    local tile = self.tile
    local checkForTarget = function(...) return self:checkForTarget(...) end
    
    fov:compute(tile.x, tile.y, sight, checkForTarget)
    if self.target then log("yarg!!"..inspect({self.target.x,self.target.y}))
    self.target.color = getColor("yellow")
        return self.target
    else
        for x = 1, #self._builtList do
            t = self._builtList[x]
            fov:compute(t.x, t.y, sight, checkForTarget)
            if self.target then
             --   warn("calculated")
                self.goal = {x=t.x, y=t.y}
                break
            end
        end
        if self.target then
            return self.target
        else
            targ = lume.randomchoice(self._toBuildList)
            self.target = self.map:getTile(targ.x,targ.y)
            self.goal = {x=self.target.x,y=self.target.y}
            self.shooting = true warn("!")
            return self.target
        end
    end
end

function Bot:checkForTarget(x, y, range, vis)
    local target = self.map:getTile(x,y)
    
    if check then target.color = getColor("purple") end
    if self._toBuild[x] and self._toBuild[x][y] then
        self.target = self.map:getTile(x,y)
        if self.target.isBackground then
            self.target = nil
            return
        end
        return true
    end
    
end

function Bot:shoot(angle)
    local newBullet = Bullet:new(self.map,{
        x = self.x,
        y = self.y,--+self.h,
        weight = 10,
        w = 10,
        h = 5,
        parent = self,
        angle = angle+math.pi*0
    }) --warn(angle)
    self.bullets[self.bulletLen+1] = newBullet
    self.bulletLen = self.bulletLen+1
end

function Bot.checkCollision(item, other)
    if other.isBackground then
        return nil
    elseif other.isPlayer then
        return nil--???
    elseif other.isBullet and other.parent == item then
        return
    else
        return "slide"
    end
end

function Bot:changeVelocityByKeys(dt)
  self.isJumpingOrFlying = false

  if not self.active then return end

  local vx, vy = self.vx, self.vy
  local dir = self.Ljoystick:getX()
  
  if dir<0 then
    vx = vx - dt * (vx > 0 and self.brakeAccel or self.runAccel) * (dir*-1)
  elseif dir>0 then
    vx = vx + dt * (vx < 0 and self.brakeAccel or self.runAccel) * dir
  else
    local brake = dt * (vx < 0 and self.brakeAccel or -self.brakeAccel)
    if math.abs(brake) > math.abs(vx) then
      vx = 0
    else
      vx = vx + brake
    end
  end
  
  if self.vx>self.maxVx then
      self.vx = self.maxVx
  end

  --[[if self.paddy:isDown("up") and (self:canFly() or self.onGround) then -- jump/fly
    vy = -jumpVelocity
    self.isJumpingOrFlying = true
  end
]]
  self.vx, self.vy = vx, vy
end

function Bot:move(x,y)
    local actualX, actualY, collisions, len = self.world:move(self,x,y,
    self.checkCollision)
    
    local col
    local ignore = false
    for i = 1, len do
        col = collisions[i]
        if col.normal.y == -1 or col.normal.x ~=0 then
            self.canJump = true
            if col.normal.y == -1 and self.gravity > 0 then
                ignore = true
                self.gravity = 0
            end
            self.jumping = false
        end
        if col.normal.y == 1 then
            --self.vy = self.initGravity/2
            self.canJump = false
        end
    end
    if nik then--self.vy>self.initGravity*.45 and not ignore then
        self.canJump = false
    end
    
    return actualX, actualY
end

function Bot:jump()
    if self.canJump then
        self.jumping = true
        self.gravity = -self.initGravity
        self.vy = self.vy-self.jumpAcceleration
    end
end

function Bot:moveUp(dt)
    local vy = self.vy
    self.vy = vy - dt * (vy > 0 and self.brakeAccel or self.runAccel)
end

function Bot:moveDown(dt)
    local vy = self.vy
    self.vy = vy + dt * (vy < 0 and self.brakeAccel or self.runAccel)
end

function Bot:moveRight(dt)
    local vx = self.vx
    self.vx = vx + dt * (vx < 0 and self.brakeAccel or self.runAccel)
end

function Bot:moveLeft(dt)
    local vx = self.vx
    self.vx = vx - dt * (vx > 0 and self.brakeAccel or self.runAccel)
end

function Bot:checkLimits()
    local maxVx,maxVy = self.maxVx, self.maxVy
    
    if self.isCrawling then
        maxVx, maxVy = self.maxCrawlX, self.maxCrawlY
    end
    
    if math.abs(self.vx)>maxVx then
        self.vx = self.maxVx*self:getDir(self.vx)
    end
    
    if math.abs(self.vy)>maxVy then
        self.vy = self.maxVy*self:getDir(self.vy)
    end
end

function Bot:update(dt) self.isCrawling = true
    self:updatePos(dt)
    if self.purpose then
    
        if self.target and self.target.isBackground then
            self._toBuild[self.target.x][self.target.y] = nil
            for x = 1, #self._toBuildList do
                dd = self._toBuildList[x]
                if dd.x == self.target.x and dd.y == self.target.y then
                    table.remove(self._toBuildList,x)
                    table.insert(self._builtList,dd)
                    break
                end
            end
            self.target = nil warn("move on")
        end
        if self.target then self.target.color=getColor("purple") end
        if not self.target then
            self:getTargetTile()
        end
        
        self:getTargetTile()
        if self.targetTile == self.tile then
            self.targetTile.color = nil
            self.targetTile = nil
          --  self:getTargetTile()
            _WARNING_COLOR = "blue"
            warn("checki")
            _WARNING_COLOR = "red"
        end
        
        if self.goal and not self.path then
            if self.reachedGoal then
                self.goal = nil
                self.reachedGoal = nil
            else
                self:getTile()
                self.path = self.map:findPathTo(self.tile,self.goal.x,self.goal.y)
                self.currentPosInPath = 1
            end
        elseif not self.goal and self.target and not self.target.isBackground then
            local angle = math.atan2((self.target._x-self.x),(self.target._y-self.y))
            a = -angle
            while a < 0 do
                a = a + math.pi*2
            end
            while a >= math.pi*2 do
                a = a - math.pi*2
            end
        
        
            self:shoot(angle-math.pi/2)
        elseif self.path and not self.targetTile then
            local zz = self.path[self.currentPosInPath]
            self.currentPosInPath = self.currentPosInPath+1
            local t = self.map:getTile(zz.x, zz.y)
            local tt = self.map:getTile(zz.x, zz.y+1)
            if tt.isBackground then
                self.isCrawling = true
            else
                self.isCrawling = false--???
            end
            self.targetTile = t
            t.color = getColor("yellow")
        elseif self.targetTile then
            local dx = self:getDir(self.targetTile.x-self.tile.x)
            local dy = self:getDir(self.targetTile.y-self.tile.y)
            if dx>0 then
                self:moveRight(dt) --error()
            elseif dx<0 then
                self:moveLeft(dt)-- error()
            end
            if dy<0 then self.isCrawling = true log("vy"..self.vy)
                self:moveUp(dt) log("vuuy"..self.vy)
            elseif dy>0 then
                self:moveDown(dt) --error()
            end
        end
    end
end

function Bot:updatePos(dt)
    self._w, self._h = resizeImage(game:getSource(self.source),self.w,self.h)
    if self.isCrawling then
        self.initGravity = 0
    end
    --self.x, self.y = self.collider:getPosition()
    --self.anglxe = self.collider:getAngle() --?????change back
    self.old.x, self.old.y = self.x, self.y
    
    for i = 1, self.bulletLen do
        local b = self.bullets[i]
        b:update(dt)
    end
    
    --self.paddy:update(dt)
    
    self.speed = {x=0,y=0}
    
    self:updateGravity(dt)
    if self.vy<0 then self.canJump = false end

    local x,y = 0,0--(0self.paddy.joystick:getX(), self.paddy.joystick:getY()
    local vx, vy = self.x+self.vx*dt,self.y+self.vy*dt
    
    self.canJump = false
    self:checkLimits()
    if 3 then--self.speed.y~=0 or self.speed.x~=0 then
        local mx, my = self:move(vx,vy)
        self.x, self.y = mx,my
    end
    self:getTile()
    
end

function Bot:draw()

    for i = 1, self.bulletLen do
        local b = self.bullets[i]
        b:draw()
    end


    
    local v = game:getSource(self.source)
    local xx,yy = v:getWidth()/2, v:getHeight()/2
    
    love.graphics.draw(game:getSource(self.source),self.x+xx,self.y+yy,self.angle,
    self._w,self._h,xx,yy)

    --self.paddy:draw()
end

function Bot:released(...)
    --self.paddy:touchreleased(...)
end

function Bot:pressed(...)
    --self.paddy:touchpressed(...)
end

function Bot:touchmoved(...)
    --self.paddy:touchmoved(...)
end

return Bot