--Bullet class
--parent should handle destroying bullet when bullet.die is true


local Bullet = Entity:extend("Bullet",1000)
local LAST_SHOT = nil

function Bullet:ne8w(_kwargs)
    
    local t = setmetatable({}, self)
    
    local kwargs = _kwargs
    if _kwargs then
        setmetatable(_kwargs,{__index=self})
        if _kwargs.name then
            --t.super = self
        end
    else
        _kwargs = self
    end
    
    t.__init__ = self.__init__
    t:__init__(kwargs)
    if not t.super then
        error()
    end
    return t
end
local getUpdateCount = getUpdateCount

function Bullet:__init__(kwargs)
    self.isBullet = true
    self.name = kwargs.name
    self.map = kwargs.map or {world={add=null}}
    self.world = kwargs.world or self.map.world or {}
    kwargs.map = self.map
    kwargs.world = self.world
    kwargs.w = wb or kwargs.w or 5 --or 10 wb or kwargs.w or wb or 2--5
    kwargs.h= hb or kwargs.h or 3 --or 5 hb or kwargs.h or hb or .5--3
    
    Entity.__init__(self,kwargs)
    self.parent = kwargs.parent
    if not self.passive then
        self.map:storeBullet(self)
        self.map.entities[self.uuid] = self
    
        self.delay = kwargs.delay or 0.35--(not De or 0.5)--????

        if not self.parent.LAST_SHOT then
            self.parent.LAST_SHOT = love.timer.getTime()
        else
           local diff = love.timer.getTime()-self.parent.LAST_SHOT
            if diff <= self.delay then
               -- LAST_SHOT = nil
                --self:passiveDestroy()
                --return self
            end
        end
        self.parent.LAST_SHOT = love.timer.getTime()
        self.parent = kwargs.parent or error("no parent")
    end
    
    self.sfx = kwargs.sfx or "bullet_shot"
    self.source = kwargs.source or "bullets/bullet.png"
    self.firstSource = self.source
    
    if type(self.parent) == "string" then
        self.parent = self.map:getItem(self.parent) or {}
    end
    
    --assert(self.angle>0)
    self.angleY = math.sin(self.angle)
    self.angleX = math.cos(self.angle)
    
    if kwargs.passive then
        self:passiveDestroy()
        return self
    end
    
    
    self.ac = kwargs.speed or kwargs.ac or 250--500
    self.initGravity = kwargs.gravity or self.initGravity
    
    self.hits = kwargs.hits or 1
    --how many seconds bullet lasts
    self.life = kwargs.life or 10
    self.attack = kwargs.attack or 1.5
    
    self.vx = self.ac*self.angleX
    self.vy = self.ac*-1*self.angleY
    
    self.angleY, self.angleX=1,1
    self.ignoresParent = true
    self.collisionType = kwargs.collisionType or "cross"
    
end

function Bullet:detectExitedParent()
  if self.ignoresParent then
    local parent = self.parent
    if not self.parent.x then warn("parent is "..inspect(self.parent,1)) return end
    local x1,y1,w1,h1 = self.x, self.y, self.w, self.h
    local x2,y2,w2,h2 = parent.x, parent.y, parent.w-2, parent.h-2
    self.ignoresParent = x1 < x2+w2 and x2 < x1+w1 and y1 < y2+h2 and y2 < y1+h1
  end
end

function Bullet:update(dt, c) 
   -- if game.gameStarted and self.parent == game.player then
  --      if dop then Rfile="bul.txt" else Rfile="sm.txt" end ProFi:start()
    --end
    if not self.active then
        return
    end
    
    self._w, self._h = resizeImage(game:getSource(self.source),self.w,self.h)

   -- self:updateGravity(dt)

    self.bounced.x = false
    self.bounced.y = false
    
    local vx, vy = self.x+self.vx*dt*self.angleX,self.y+self.vy*dt*self.angleY

    if 1 then --???
        local mx, my = self:move(vx,vy,dt)
        self.x, self.y = mx,my
    end

    self:detectExitedParent()

    self:getTile()

    if game.gameStarted and self.parent == game.player then
   --     ProFi:stop()  ProFi:writeReport(Rfile) sw() assert(not dop) self:destroy() dop=4
    end
    
    if self.tile and not self.tile.isBackground then
        warn("passed through!")
    end
  
end

function Bullet:ignore(item)
    return item.isMini or item.isPuff or item.isFloor
end

function Bullet.checkCollision(item, other)
    if other.isTile and not item.parent.breakBlocks and other.parent and other.parent.team==item.parent.team then
        return nil
    end
    if other.isTile and not other.isBackground then
   --     other.life = other.life - item.attack
     --   item.die = true
        return item.collisionType
    end
    
    if other == item.parent and item.ignoresParent then
        return nil
    elseif other.isBullet or other.isFire then
        return item.collisionType
    elseif other.isPuff then
        return nil
    elseif not other.isBackground and not item:ignore(other) then
        return item.collisionType
    end


end

function Bullet:destroy()
    Entity.destroy(self)
    --Explosion:new({map=self.map,x=self.x, y=self.y,life=2})
end

function Bullet:passiveDestroy()
    Entity.destroy(self)
end

function Bullet:move(x,y,dt)
    self.die = false
    self.life = self.life - dt
    if self.life<=0 then
        self.die = true
    end
    
    
    if not self.active then
        return 0,0
    end
    local actualX, actualY, collisions, len = self.world:move(self,x,y,
    self.checkCollision)
    local cc
    
    for u = 1,len do
        cc = collisions[u]
        if cc.other.isFloor and len==1 then
           -- self:destroy()
           -- self.die=1
            
        end
        Entity.resolveCollision(self,cc)
        if nil and cc.other.life>0 and not self.die then--removed attacking
            for i = 1, self.hits do
                cc.other:getAttacked(self)
                self.hits = self.hits-1
                if not cc.other.isTile then
                    cc.other:applyImpulse(self.vx/2, self.vy/2)
                    --self.map.camera:shakeObject(cc.other,10,.1)
                end
                if cc.other.life <=0 then
                    if cc.other.isTile then
                       -- cc.other:destroy()
                    end
                    break
                end
                if self.isBouncyBullet then
                    break
                end
            end
        end
        --log("shooting ...")
        --??fix??
      --  if cc.other.isTile  and not cc.other:updating() then--??
        --    cc.other:update(dt)
    --    end
        --die if hit to many things
        if self.hits<=0 then
            self.die = true
        end
        --log("...bull")

    end
    
    if self.die then
        --self:destroy()
    end
    
    return actualX, actualY
end

--todo: draw trail
function Bullet:draw()

    local v = game:getSource(self.source)
    local xx,yy,xxy,yyy = 0,0,v:getWidth()/2, v:getHeight()/2
    if self.isBouncyBullet then
    --    xx,yy=8,8
    end
    local ca = math.pi^2
    --local ang = math.deg(self.angle)
    local h = self.parent and self.parent.h/2 or 0
    if self.parent and self.parent.flipX == -1 then xx = -self.parent.w/2 end
    
    --simplified it to work for only one bullet(bouncy)
    --drawing is buggy the pirate if not like this
    love.graphics.draw(game:getSource(self.source),self.x,self.y,0,self._w,self._h)
    --,self.x+(self.w/1.5)+xx,self.y+h,-(self.angle),
    --self._w,self._h,0,yyy)

    --love.graphics.print(self.angleX..", "..self.angleY,self.x,self.y)
    
end

return Bullet